HTMLManagerServlet (Apache Tomcat 11.0.24 API Documentation)
Description: declaration: package: org.apache.catalina.manager, class: HTMLManagerServlet

# Class HTMLManagerServlet

java.lang.Object
jakarta.servlet.GenericServlet
jakarta.servlet.http.HttpServlet
org.apache.catalina.manager.ManagerServlet
org.apache.catalina.manager.HTMLManagerServlet

All Implemented Interfaces:
  `Servlet, ServletConfig, Serializable, ContainerServlet`

public class HTMLManagerServlet extends ManagerServlet
Servlet that enables remote management of the web applications deployed within the same virtual host as this web application is. Normally, this functionality will be protected by a security constraint in the web application deployment descriptor. However, this requirement can be relaxed during testing.

The difference between the `ManagerServlet` and this Servlet is that this Servlet prints out an HTML interface which makes it easier to administrate.

However if you use a software that parses the output of `ManagerServlet` you won't be able to upgrade to this Servlet since the output are not in the same format ar from `ManagerServlet`

See Also:
  - `ManagerServlet`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class ManagerServlet

  `configBase, context, debug, global, host, mBeanServer, oname, sm, versioned, wrapper`

  ### Fields inherited from class HttpServlet

  `LEGACY_DO_HEAD`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HTMLManagerServlet()`
  Constructs a new HTMLManagerServlet.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected String`
  `deployInternal(String config, ContextName cn, String war, StringManager smClient)`
  Deploy an application for the specified path from the specified web application archive.
  `protected void`
  `displaySessionDetailPage(HttpServletRequest req, HttpServletResponse resp, ContextName cn, String sessionId, StringManager smClient)`
  Display session details.
  `protected void`
  `displaySessionsListPage(ContextName cn, HttpServletRequest req, HttpServletResponse resp, StringManager smClient)`
  List session.
  `void`
  `doGet(HttpServletRequest request, HttpServletResponse response)`
  Called by the server (via the `service` method) to allow a servlet to handle a GET request.
  `void`
  `doPost(HttpServletRequest request, HttpServletResponse response)`
  Called by the server (via the `service` method) to allow a servlet to handle a POST request.
  `protected void`
  `doSessions(ContextName cn, HttpServletRequest req, HttpServletResponse resp, StringManager smClient)`
  Handle session operations.
  `protected String`
  `expireSessions(ContextName cn, HttpServletRequest req, StringManager smClient)`
  Extract the expiration request parameter
  `protected String`
  `findleaks(StringManager smClient)`
  Find potential memory leaks caused by web application reload.
  `protected Comparator<Session>`
  `getComparator(String sortBy)`
  Get a comparator for sessions based on the specified sort criteria.
  `String`
  `getServletInfo()`
  Returns information about the servlet, such as author, version, and copyright.
  `protected Session`
  `getSessionForNameAndId(ContextName cn, String id, StringManager smClient)`
  Get a specific session by ID for the specified context.
  `protected List<Session>`
  `getSessionsForName(ContextName cn, StringManager smClient)`
  Get all sessions for the specified context.
  `void`
  `init()`
  A convenience method which can be overridden so that there's no need to call `super.init(config)`.
  `protected int`
  `invalidateSessions(ContextName cn, String[] sessionIds, StringManager smClient)`
  Invalidate specified sessions.
  `protected void`
  `list(HttpServletRequest request, HttpServletResponse response, String message, StringManager smClient)`
  Render an HTML list of the currently active Contexts in our virtual host, and memory and server status information.
  `protected String`
  `reload(ContextName cn, StringManager smClient)`
  Reload the web application at the specified context path.
  `protected boolean`
  `removeSessionAttribute(ContextName cn, String sessionId, String attributeName, StringManager smClient)`
  Removes an attribute from an HttpSession
  `protected String`
  `sessions(ContextName cn, int idle, StringManager smClient)`
  Display session information and invoke list.
  `protected void`
  `sslConnectorCerts(HttpServletRequest request, HttpServletResponse response, StringManager smClient)`
  Display SSL connector certificate information.
  `protected void`
  `sslConnectorCiphers(HttpServletRequest request, HttpServletResponse response, StringManager smClient)`
  Display SSL connector cipher information.
  `protected void`
  `sslConnectorTrustedCerts(HttpServletRequest request, HttpServletResponse response, StringManager smClient)`
  Display SSL connector trusted certificate information.
  `protected String`
  `sslReload(String tlsHostName, StringManager smClient)`
  Reload SSL configuration for the specified host.
  `protected String`
  `start(ContextName cn, StringManager smClient)`
  Start the web application at the specified context path.
  `protected String`
  `stop(ContextName cn, StringManager smClient)`
  Stop the web application at the specified context path.
  `protected String`
  `undeploy(ContextName cn, StringManager smClient)`
  Undeploy the web application at the specified context path.
  `protected String`
  `upload(HttpServletRequest request, StringManager smClient)`
  Upload a WAR file for deployment.

  ### Methods inherited from class ManagerServlet

  `check, deploy, deploy, deploy, destroy, doPut, expireSessions, findleaks, getConnectorCerts, getConnectorCiphers, getConnectorTrustedCerts, getWrapper, isDeployed, list, printResources, reload, removeServiced, resources, save, serverinfo, sessions, setWrapper, sslConnectorCiphers, sslReload, start, stop, threadDump, tryAddServiced, undeploy, uploadWar, validateContextName, vmInfo`

  ### Methods inherited from class HttpServlet

  `doDelete, doHead, doOptions, doPatch, doTrace, getLastModified, init, isSensitiveHeader, service, service`

  ### Methods inherited from class GenericServlet

  `getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletName, log, log`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### HTMLManagerServlet

    public HTMLManagerServlet()
    Constructs a new HTMLManagerServlet.

- ## Method Details

  - ### doGet

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    Description copied from class: `jakarta.servlet.http.HttpServlet`
    Called by the server (via the `service` method) to allow a servlet to handle a GET request.

    Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

    When overriding this method, read the request data, write the response headers, get the response's Writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

    The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

    Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

    When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

    The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

    The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

    If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

    Overrides:
      `doGet` in class `ManagerServlet`
    Parameters:
      `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
      `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
    Throws:
      `IOException` - if an input or output error is detected when the servlet handles the GET request
      `ServletException` - if the request for the GET could not be handled
    See Also:
      - `ServletResponse.setContentType(String)`

  - ### doPost

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    Description copied from class: `jakarta.servlet.http.HttpServlet`
    Called by the server (via the `service` method) to allow a servlet to handle a POST request. The HTTP POST method allows the client to send data of unlimited length to the Web server a single time and is useful when posting information such as credit card numbers.

    When overriding this method, read the request data, write the response headers, get the response's Writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

    The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

    Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

    When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

    This method does not need to be either safe or idempotent. Operations requested through POST can have side effects for which the user can be held accountable, for example, updating stored data or buying items online.

    If the HTTP POST request is incorrectly formatted, `doPost` returns an HTTP "Bad Request" message.

    Overrides:
      `doPost` in class `HttpServlet`
    Parameters:
      `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
      `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
    Throws:
      `IOException` - if an input or output error is detected when the servlet handles the request
      `ServletException` - if the request for the POST could not be handled
    See Also:
      - `ServletOutputStream`
      - `ServletResponse.setContentType(String)`

  - ### upload

    protected String upload(HttpServletRequest request, StringManager smClient)
    Upload a WAR file for deployment.
    Parameters:
      `request` - the HTTP servlet request
      `smClient` - internationalized strings
    Returns:
      message string describing the result of the upload

  - ### deployInternal

    protected String deployInternal(String config, ContextName cn, String war, StringManager smClient)
    Deploy an application for the specified path from the specified web application archive.
    Parameters:
      `config` - URL of the context configuration file to be deployed
      `cn` - Name of the application to be deployed
      `war` - URL of the web application archive to be deployed
      `smClient` - internationalized strings
    Returns:
      message String

  - ### list

    protected void list(HttpServletRequest request, HttpServletResponse response, String message, StringManager smClient) throws IOException
    Render an HTML list of the currently active Contexts in our virtual host, and memory and server status information.
    Parameters:
      `request` - The request
      `response` - The response
      `message` - a message to display
      `smClient` - internationalized strings
    Throws:
      `IOException` - an IO error occurred

  - ### reload

    protected String reload(ContextName cn, StringManager smClient)
    Reload the web application at the specified context path.
    Parameters:
      `cn` - Name of the application to be restarted
      `smClient` - StringManager for the client's locale
    Returns:
      message String
    See Also:
      - `ManagerServlet.reload(PrintWriter, ContextName, StringManager)`

  - ### undeploy

    protected String undeploy(ContextName cn, StringManager smClient)
    Undeploy the web application at the specified context path.
    Parameters:
      `cn` - Name of the application to be undeployed
      `smClient` - StringManager for the client's locale
    Returns:
      message String
    See Also:
      - `ManagerServlet.undeploy(PrintWriter, ContextName, StringManager)`

  - ### sessions

    protected String sessions(ContextName cn, int idle, StringManager smClient)
    Display session information and invoke list.
    Parameters:
      `cn` - Name of the application to list session information
      `idle` - Expire all sessions with idle time ≥ idle for this context
      `smClient` - StringManager for the client's locale
    Returns:
      message String
    See Also:
      - `ManagerServlet.sessions(PrintWriter, ContextName, int, StringManager)`

  - ### start

    protected String start(ContextName cn, StringManager smClient)
    Start the web application at the specified context path.
    Parameters:
      `cn` - Name of the application to be started
      `smClient` - StringManager for the client's locale
    Returns:
      message String
    See Also:
      - `ManagerServlet.start(PrintWriter, ContextName, StringManager)`

  - ### stop

    protected String stop(ContextName cn, StringManager smClient)
    Stop the web application at the specified context path.
    Parameters:
      `cn` - Name of the application to be stopped
      `smClient` - StringManager for the client's locale
    Returns:
      message String
    See Also:
      - `ManagerServlet.stop(PrintWriter, ContextName, StringManager)`

  - ### findleaks

    protected String findleaks(StringManager smClient)
    Find potential memory leaks caused by web application reload.
    Parameters:
      `smClient` - StringManager for the client's locale
    Returns:
      message String
    See Also:
      - `ManagerServlet.findleaks(boolean, PrintWriter, StringManager)`

  - ### sslReload

    protected String sslReload(String tlsHostName, StringManager smClient)
    Reload SSL configuration for the specified host.
    Parameters:
      `tlsHostName` - the TLS host name
      `smClient` - internationalized strings
    Returns:
      message string describing the result

  - ### sslConnectorCiphers

    protected void sslConnectorCiphers(HttpServletRequest request, HttpServletResponse response, StringManager smClient) throws ServletException, IOException
    Display SSL connector cipher information.
    Parameters:
      `request` - the HTTP servlet request
      `response` - the HTTP servlet response
      `smClient` - internationalized strings
    Throws:
      `ServletException` - a servlet error occurred
      `IOException` - an I/O error occurred

  - ### sslConnectorCerts

    protected void sslConnectorCerts(HttpServletRequest request, HttpServletResponse response, StringManager smClient) throws ServletException, IOException
    Display SSL connector certificate information.
    Parameters:
      `request` - the HTTP servlet request
      `response` - the HTTP servlet response
      `smClient` - internationalized strings
    Throws:
      `ServletException` - a servlet error occurred
      `IOException` - an I/O error occurred

  - ### sslConnectorTrustedCerts

    protected void sslConnectorTrustedCerts(HttpServletRequest request, HttpServletResponse response, StringManager smClient) throws ServletException, IOException
    Display SSL connector trusted certificate information.
    Parameters:
      `request` - the HTTP servlet request
      `response` - the HTTP servlet response
      `smClient` - internationalized strings
    Throws:
      `ServletException` - a servlet error occurred
      `IOException` - an I/O error occurred

  - ### getServletInfo

    public String getServletInfo()
    Description copied from class: `jakarta.servlet.GenericServlet`
    Returns information about the servlet, such as author, version, and copyright. By default, this method returns an empty string. Override this method to have it return a meaningful value. See `Servlet.getServletInfo()`.
    Specified by:
      `getServletInfo` in interface `Servlet`
    Overrides:
      `getServletInfo` in class `GenericServlet`
    Returns:
      String information about this servlet, by default an empty string

  - ### init

    public void init() throws ServletException
    Description copied from class: `jakarta.servlet.GenericServlet`
    A convenience method which can be overridden so that there's no need to call `super.init(config)`.

    Instead of overriding `GenericServlet.init(ServletConfig)`, simply override this method and it will be called by `GenericServlet.init(ServletConfig config)`. The `ServletConfig` object can still be retrieved via `GenericServlet.getServletConfig()`.

    Overrides:
      `init` in class `ManagerServlet`
    Throws:
      `ServletException` - if an exception occurs that interrupts the servlet's normal operation

  - ### expireSessions

    protected String expireSessions(ContextName cn, HttpServletRequest req, StringManager smClient)
    Extract the expiration request parameter
    Parameters:
      `cn` - Name of the application from which to expire sessions
      `req` - The Servlet request
      `smClient` - StringManager for the client's locale
    Returns:
      message string

  - ### doSessions

    protected void doSessions(ContextName cn, HttpServletRequest req, HttpServletResponse resp, StringManager smClient) throws ServletException, IOException
    Handle session operations.
    Parameters:
      `cn` - Name of the application for the sessions operation
      `req` - The Servlet request
      `resp` - The Servlet response
      `smClient` - StringManager for the client's locale
    Throws:
      `ServletException` - Propagated Servlet error
      `IOException` - An IO error occurred

  - ### getSessionsForName

    protected List<Session> getSessionsForName(ContextName cn, StringManager smClient)
    Get all sessions for the specified context.
    Parameters:
      `cn` - the context name
      `smClient` - internationalized strings
    Returns:
      list of sessions for the context

  - ### getSessionForNameAndId

    protected Session getSessionForNameAndId(ContextName cn, String id, StringManager smClient)
    Get a specific session by ID for the specified context.
    Parameters:
      `cn` - the context name
      `id` - the session ID
      `smClient` - internationalized strings
    Returns:
      the session, or `null` if not found

  - ### displaySessionsListPage

    protected void displaySessionsListPage(ContextName cn, HttpServletRequest req, HttpServletResponse resp, StringManager smClient) throws ServletException, IOException
    List session.
    Parameters:
      `cn` - Name of the application for which the sessions will be listed
      `req` - The Servlet request
      `resp` - The Servlet response
      `smClient` - StringManager for the client's locale
    Throws:
      `ServletException` - Propagated Servlet error
      `IOException` - An IO error occurred

  - ### displaySessionDetailPage

    protected void displaySessionDetailPage(HttpServletRequest req, HttpServletResponse resp, ContextName cn, String sessionId, StringManager smClient) throws ServletException, IOException
    Display session details.
    Parameters:
      `req` - The Servlet request
      `resp` - The Servlet response
      `cn` - Name of the application for which the sessions will be listed
      `sessionId` - the session id
      `smClient` - StringManager for the client's locale
    Throws:
      `ServletException` - Propagated Servlet error
      `IOException` - An IO error occurred

  - ### invalidateSessions

    protected int invalidateSessions(ContextName cn, String[] sessionIds, StringManager smClient)
    Invalidate specified sessions.
    Parameters:
      `cn` - Name of the application for which sessions are to be invalidated
      `sessionIds` - the session ids of the sessions
      `smClient` - StringManager for the client's locale
    Returns:
      number of invalidated sessions

  - ### removeSessionAttribute

    protected boolean removeSessionAttribute(ContextName cn, String sessionId, String attributeName, StringManager smClient)
    Removes an attribute from an HttpSession
    Parameters:
      `cn` - Name of the application hosting the session from which the attribute is to be removed
      `sessionId` - the session id
      `attributeName` - the attribute name
      `smClient` - StringManager for the client's locale
    Returns:
      true if there was an attribute removed, false otherwise

  - ### getComparator

    protected Comparator<Session> getComparator(String sortBy)
    Get a comparator for sessions based on the specified sort criteria.
    Parameters:
      `sortBy` - the sort criteria
    Returns:
      the comparator, or `null` if the sort criteria is not recognized